'use strict';

//https://cdn.jsdelivr.net/npm/a_js_f@version/file

var a_js_f = {
	$: function $(context) {
		var app = document.getElementById(context.element);
		app.innerHTML = context.template;
		if (context.mounted) context.mounted();
	},
	_: function _(element, context) {
		var errors = ['MUST BE a function (that returns numbers or strings), numbers or strings', 'Don\'t use both render and $render'];
		var finishedElement;
		if (!context) {
			finishedElement = '<' + element + ' />';
		} else {
			if (context === Object(context)) {
				var finalAttrs = '';
				var _iteratorNormalCompletion = true;
				var _didIteratorError = false;
				var _iteratorError = undefined;

				try {
					for (var _iterator = Object.keys(context)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
						var key = _step.value;

						if (key === 'render' || key === '$render') {
							if (context.render && context.$render) {
								console.error(errors[1]);
							} else {
								if (typeof key === 'string' || typeof key === 'number') {
									finishedElement = '<' + element + ' ' + finalAttrs + '>' + context[key] + '</' + element + '>';
								} else if (typeof key === 'function') {
									finishedElement = '<' + element + ' ' + finalAttrs + '>' + context[key]() + '</' + element + '>';
								} else {
									console.error('Render ' + errors[0]);
								}
							}
						} else {
							if (typeof context[key] === 'number' || typeof context[key] === 'string') {
								finalAttrs = finalAttrs + key + '="' + context[key] + '" ';
							} else if (typeof context[key] === 'function') {
								finalAttrs = finalAttrs + key + '="' + context[key]() + '" ';
							} else {
								console.error('Atributtes ' + errors[0]);
							}
							if (!context.render && !context.$render) {
								finishedElement = '<' + element + ' ' + finalAttrs + '></' + element + '>';
							}
						}
					}
				} catch (err) {
					_didIteratorError = true;
					_iteratorError = err;
				} finally {
					try {
						if (!_iteratorNormalCompletion && _iterator.return) {
							_iterator.return();
						}
					} finally {
						if (_didIteratorError) {
							throw _iteratorError;
						}
					}
				}
			} else {
				finishedElement = '<' + element + '>' + context + '</' + element + '>';
			}
		}
		return finishedElement;
	}
};

//shothands
var createElement = a_js_f._,
    render = a_js_f.$;

function div(r) {
	return a_js_f._('div', r);
}

function header(r) {
	return a_js_f._('header', r);
}

function h1(r) {
	return a_js_f._('h1', r);
}

function p(r) {
	return a_js_f._('p', r);
}
function h2(r) {
	return a_js_f._('h2', r);
}
function h3(r) {
	return a_js_f._('h3', r);
}
function h4(r) {
	return a_js_f._('h4', r);
}
function h5(r) {
	return a_js_f._('h5', r);
}
function ul(r) {
	return a_js_f._('ul', r);
}
function li(r) {
	return a_js_f._('li', r);
}
function a(r) {
	return a_js_f._('a', r);
}

function br() {
	return a_js_f._('br');
}

function button(r) {
	return a_js_f._('button', r);
}
function main(r) {
	return a_js_f._('main', r);
}
function section(r) {
	return a_js_f._('section', r);
}
