//https://cdn.jsdelivr.net/npm/another_javascript_framework/dist/a_js_f.es5.min.js

const a_js_f = {
	$(context) {
		let app = document.getElementById(context.element)
		app.innerHTML = context.template
		if (context.mounted) context.mounted()
	},
	_(element, context) {
		const errors = [
			'MUST BE a function (that returns numbers or strings), numbers or strings',
			'Don\'t use both render and $render'
		]
		var finishedElement
		if (!context) {
			finishedElement = `<${element} />`
		} else {
			if (context === Object(context)) {
				var finalAttrs = ''
				for (const key of Object.keys(context)) {
					if (key === 'render' || key === '$render') {
						if (context.render && context.$render) {
							console.error(errors[1])
						} else {
							if (typeof key === 'string' || typeof key === 'number') {
								finishedElement = `<${element} ${finalAttrs}>${context[key]}</${element}>`
							} else if (typeof key === 'function') {
								finishedElement = `<${element} ${finalAttrs}>${context[key]()}</${element}>`
							} else {
								console.error('Render ' + errors[0])
							}
						}
					} else {
						if (typeof context[key] === 'number' || typeof context[key] === 'string') {
							finalAttrs = finalAttrs + key + '="' + context[key] + '" '
						} else if (typeof context[key] === 'function') {
							finalAttrs = finalAttrs + key + '="' + context[key]() + '" '
						} else {
							console.error('Atributtes ' + errors[0])
						}
						if (!context.render && !context.$render) {
							finishedElement = `<${element} ${finalAttrs}></${element}>`
						}
					}

				}
			} else {
				finishedElement = `<${element}>${context}</${element}>`
			}

		}
		return finishedElement
	}
}





//shothands
const createElement = a_js_f._,
	render = a_js_f.$

function div(r) {
	return a_js_f._('div', r)
}

function header(r) {
	return a_js_f._('header', r)
}

function h1(r) {
	return a_js_f._('h1', r)
}

function p(r) {
	return a_js_f._('p', r)
}
function h2(r) {
	return a_js_f._('h2', r)
}
function h3(r) {
	return a_js_f._('h3', r)
}
function h4(r) {
	return a_js_f._('h4', r)
}
function h5(r) {
	return a_js_f._('h5', r)
}
function ul(r) {
	return a_js_f._('ul', r)
}
function li(r) {
	return a_js_f._('li', r)
}
function a(r) {
	return a_js_f._('a', r)
}

function br() {
	return a_js_f._('br')
}

function button(r) {
	return a_js_f._('button', r)
}
function main(r) {
	return a_js_f._('main', r)
}
function section(r) {
	return a_js_f._('section', r)
}


